package com.ruoyi.project.business.mapper.quotation;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.project.business.domain.TqQuotation;
import com.ruoyi.project.business.domain.bo.quotation.QuotationQueryBO;
import com.ruoyi.project.business.domain.vo.quotation.H5QuotationDetailVO;
import com.ruoyi.project.business.domain.vo.quotation.QuotationApprovalVO;
import com.ruoyi.project.business.domain.vo.quotation.QuotationDetailVO;
import com.ruoyi.project.business.domain.vo.quotation.QuotationExportVO;
import com.ruoyi.project.business.domain.vo.quotation.QuotationVO;
import com.ruoyi.project.business.domain.vo.quotation.QuotationVersionVO;
import java.math.BigDecimal;
import java.util.List;
import org.apache.ibatis.annotations.Param;

/**
 * 【请填写功能名称】Mapper接口
 *
 * @author ruoyi
 * @date 2024-05-10
 */
public interface TqQuotationMapper extends BaseMapper<TqQuotation> {

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    public TqQuotation selectTqQuotationById(Long id);

    public QuotationDetailVO selectDetailById(Long id);

    /**
     * 查询【请填写功能名称】列表
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 【请填写功能名称】集合
     */
    public List<QuotationVO> selectTqQuotationList(QuotationQueryBO tqQuotation);

    /**
     * 新增【请填写功能名称】
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 结果
     */
    public int insertTqQuotation(TqQuotation tqQuotation);

    /**
     * 修改【请填写功能名称】
     *
     * @param tqQuotation 【请填写功能名称】
     * @return 结果
     */
    public int updateTqQuotation(TqQuotation tqQuotation);

    /**
     * 删除【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    public int deleteTqQuotationById(Long id);

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTqQuotationByIds(Long[] ids);

    List<QuotationVersionVO> getMaxVersionById(@Param("list") List<Long> ids);

    List<QuotationVO> listByProjectId(Long projectId);

    List<Long> getAreaIdByProjectId(Long id);

    void updateAuditOptionalPrice(@Param("id") Long id,
        @Param("price") BigDecimal quotationOptionalPrice);

    List<QuotationApprovalVO> listPendingApproval(String userId);

    H5QuotationDetailVO detailApproval(Long quotationId);

    List<QuotationExportVO> listQuotationExport(List<Long> quotationIdList);
}
